# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`yarn`](#yarn): Install and configure Yarn

#### Private Classes

* `yarn::install`: Install Yarn
* `yarn::repo`: Ensure yarnpkg.com is used as source for package manager

## Classes

### `yarn`

Install and configure Yarn

#### Parameters

The following parameters are available in the `yarn` class.

##### `package_ensure`

Data type: `Enum['present','absent']`

with `present` Yarn is installed
with `absent` Yarn is uninstalled

Default value: `'present'`

##### `package_name`

Data type: `String[1]`

The name of package expected to be installed with package manager provided by your OS or by npm.

Default value: `'yarn'`

##### `manage_repo`

Data type: `Boolean`

with `true` a new source using yarnpkg.com is added in the package manager of your OS.
with `false` do nothing
Default value: handled by hiera data of the module.

##### `install_method`

Data type: `Enum['npm', 'source', 'package']`

with `source` the `source_url` is used to get and install Yarn
with `package` the package manager provider by OS is used to install Yarn
with `npm` the npm packahe manager is used to install Yarn
Default value: handled by hiera data of the module.

##### `source_install_dir`

Data type: `Stdlib::Absolutepath`

path where Yarn sources are installed with `install_method` to `source`

Default value: `'/opt'`

##### `symbolic_link`

Data type: `Stdlib::Absolutepath`

the `yarn` command in the path pointing to the installed `yarn` with `install_method` to `source`

Default value: `'/usr/local/bin/yarn'`

##### `user`

Data type: `String[1]`

the user account on node owner of installed files with `install_method` to `source` or `npm`

Default value: `'root'`

##### `source_url`

Data type: `Stdlib::HTTPUrl`

URL where the sources are downloaded from

Default value: `'https://yarnpkg.com/latest.tar.gz'`

